import fxconv as fx
class Lexer:
    def __init__(self,Data):
        # remove first line...
        Data = Data.split("\n",1)[1]

        self.data = Data.split()
        
        # ... and last line
        self.data = self.data[0:len(self.data)-2]
    
    def lex(self,indice):

        return self.data[indice]
    def getData(self):
        return self.data

class Parser:
    def __init__(self,Lexer):
        self.lexer = Lexer
    def parse(self,Data):
        list_triangles = [[[0,0,0],[0,0,0],[0,0,0]] for i in range(int(len(Data)/21))]
        triangle=0
        # for all the triangles
        
        for i in range(0,len(Data),21):
            # parsing X
            for j in range(0,3):
                list_triangles[triangle][0][j] = float(self.lexer.lex(i+8+j))
            # parsing Y
            for j in range(0,3):
                list_triangles[triangle][1][j] = float(self.lexer.lex(i+12+j))
            # parsing Z
            for j in range(0,3):
                list_triangles[triangle][2][j] = float(self.lexer.lex(i+16+j))
    
            triangle+=1
        return list_triangles

def format(data):
    vertex_list = []
    for i in data:
        for j in i:
            if not j in vertex_list:
                vertex_list.append(j)
    face_list = []
    for i in data:
        vertex = []
        for j in i:
            vertex.append(vertex_list.index(j))
        face_list.append(vertex)
    return vertex_list,face_list

def multiplybyfactor(array, factor):
    a = 0
    for i in array:
        b=0
        for j in i: 
            array[a][b] = j*factor
            b+=1
        a+=1
    return array

def convert(input, output, params, target):
    if params["custom-type"] == "stl":
        convert_stl(input, output, params, target)
        return 0
    else:
        return 1
def convert_stl(input,output,params,target):
    with open(input) as file:
        data = file.read()
        lexer = Lexer(data)
        Data = lexer.getData()
        parser = Parser(lexer)
        vertexlist,facelist = format(parser.parse(Data))
        vertexlist = multiplybyfactor(vertexlist,(1/max(max(vertexlist, key=max)))*30)
        vertex = fx.Structure()
        for i in vertexlist:
            vertex += fx.u32(int(i[0]))+fx.u32(int(i[1]))+fx.u32(int(i[2]))
        vertex += bytes(2)    
    
        texture = fx.Structure()
        texture += fx.u32(0) + fx.u32(1)
        
        face = fx.Structure()
        for z in facelist:
            face += fx.ptr("tex_black")
            face += fx.ptr("tex_black")
            face += fx.u8(int(z[0]))+fx.u8(int(z[1]))+fx.u8(int(z[2])) + fx.u8(0) + fx.u8(0) + fx.u8(0)
            face += fx.u8(1)
            face += bytes(1)
        
        mesh = fx.Structure()
        mesh += fx.ptr(vertex)
        mesh += fx.u32(len(vertexlist))
        mesh += fx.ptr(texture)
        mesh += fx.u32(1)
        mesh += fx.ptr(face)
        mesh += fx.u32(len(facelist))

        fx.elf(mesh, output, "_" + params["name"], **target)
        


